/********************************************************************
/*Name:		Shuang Xu
/*DePaul ID:	0255454
/*Course No:	SE455, Software Development Methods
/*Instructor:	Robert Stalzer
/*Project Name: Tetris
/*******************************************************************/

/*
Using VISITOR for class FillingCells. There are four subclasses dealing with the 
four positions for each shape object.
*/

class FillingCellsat9 implements FillingCells {
    protected Shape shape;
    protected FilledCells fc;

    public FillingCellsat9 (Shape s) {
	if (s!=null) shape =s;
    }

    public FilledCells FillingCube(){
	int length = 4;	
	int cells[][] = new int [length][2];
	int row = shape.getRow();
	int col = shape.getColumn();

	cells[0][0] = row;
	cells[0][1] = col;
	cells[1][0] = row;
	cells[1][1] = col + 1;
	cells[2][0] = row + 1;
	cells[2][1] = col;
	cells[3][0] = row + 1;
	cells[3][1] = col + 1;
	fc = new FilledCells( length, cells);
	return fc;
    }

    public FilledCells FillingL(){
	int length = 4;	
	int cells[][] = new int [length][2];
	int row = shape.getRow();
	int col = shape.getColumn();

	cells[0][0] = row;
	cells[0][1] = col;
	cells[1][0] = row + 1;
	cells[1][1] = col;
	cells[2][0] = row + 2;
	cells[2][1] = col;
	cells[3][0] = row + 2;
	cells[3][1] = col + 1;
	fc = new FilledCells( length, cells);
	return fc;
    }

    public FilledCells FillingBL(){
	int length = 4;	
	int cells[][] = new int [length][2];
	int row = shape.getRow();
	int col = shape.getColumn();

	cells[0][0] = row;
	cells[0][1] = col;
	cells[1][0] = row;
	cells[1][1] = col + 1;
	cells[2][0] = row + 1;
	cells[2][1] = col;
	cells[3][0] = row + 2;
	cells[3][1] = col;
	fc = new FilledCells( length, cells);
	return fc;
    }

    public FilledCells FillingStair(){
	int length = 4;	
	int cells[][] = new int [length][2];
	int row = shape.getRow();
	int col = shape.getColumn();

	cells[0][0] = row;
	cells[0][1] = col + 1;
	cells[1][0] = row;
	cells[1][1] = col + 2;
	cells[2][0] = row + 1;
	cells[2][1] = col;
	cells[3][0] = row + 1;
	cells[3][1] = col + 1;
	fc = new FilledCells( length, cells);
	return fc;
    }

    public FilledCells FillingBStair(){
	int length = 4;	
	int cells[][] = new int [length][2];
	int row = shape.getRow();
	int col = shape.getColumn();

	cells[0][0] = row;
	cells[0][1] = col;
	cells[1][0] = row;
	cells[1][1] = col + 1;
	cells[2][0] = row + 1;
	cells[2][1] = col + 1;
	cells[3][0] = row + 1;
	cells[3][1] = col + 2;
	fc = new FilledCells( length, cells);
	return fc;
    }

    public FilledCells FillingT(){
	int length = 4;	
	int cells[][] = new int [length][2];
	int row = shape.getRow();
	int col = shape.getColumn();

	cells[0][0] = row;
	cells[0][1] = col + 1;
	cells[1][0] = row + 1;
	cells[1][1] = col;
	cells[2][0] = row + 1;
	cells[2][1] = col + 1;
	cells[3][0] = row + 2;
	cells[3][1] = col + 1;
	fc = new FilledCells( length, cells);
	return fc;
    }

    public FilledCells FillingStick(){
	int length = 4;	
	int cells[][] = new int [length][2];
	int row = shape.getRow();
	int col = shape.getColumn();

	cells[0][0] = row;
	cells[0][1] = col + 2;
	cells[1][0] = row + 1;
	cells[1][1] = col + 2;
	cells[2][0] = row + 2;
	cells[2][1] = col + 2;
	cells[3][0] = row + 3;
	cells[3][1] = col + 2;
	fc = new FilledCells( length, cells);
	return fc;
    }
}

